<?php
/**
* @project    Atom-M CMS
* @package    Additional Fields (Admin Part)
* @url        http://atom-m.net
*/



include_once '../sys/boot.php';
include_once ROOT . '/admin/inc/adm_boot.php';




// Know module
$ModulesManager = new ModulesManager();
$allow_modules = $ModulesManager->getAddFieldsAllowedModules();
$modules_titles = $ModulesManager->getAddFieldsAllowedModulesTitles();




if (empty($_GET['m']) || !in_array($_GET['m'], $allow_modules)) {
    $_GET['m'] = 'news';
    $_GET['ac'] = 'index';
}


$Register = Register::getInstance();
$Register['module'] = $_GET['m'];

$pageTitle = $modules_titles[$_GET['m']] . ' - ' . __('Additional fields');

// Know action
if (!isset($_GET['ac'])) $_GET['ac'] = 'index';
$permis = array('add', 'del', 'index', 'edit');
if (!in_array($_GET['ac'], $permis)) $_GET['ac'] = 'index';

switch($_GET['ac']) {
    case 'del':
        $content = FpsDelete();
        break;
    case 'add':
        $content = FpsAdd();
        break;
    case 'edit':
        $content = FpsEdit();
        break;
    default:
}




if ($_GET['ac'] == 'index'):
    $where = array('module' => $_GET['m']);
    $fields = $FpsDB->select('add_fields', DB_ALL, array('cond' => $where));
    $AddFields = new AtmAddFields;
    if (count($fields) > 0)
        $inputs = $AddFields->getInputs($fields, $_GET['m']);




    $pageNav = $pageTitle;
    $pageNavr = '';
    //echo $head
    include_once ROOT . '/admin/template/header.php';
?>

    <div class="popup" id="addCat">
        <div class="top">
            <div class="title"><?php echo __('Adding field') ?></div>
            <div class="close" onClick="closePopup('addCat')"></div>
        </div>
        <div class="items">
            <form action="additional_fields.php?m=<?php echo $_GET['m'] ?>&ac=add" method="POST">
            <div class="item">
                <div class="left">
                    <?php echo __('Type of field') ?>:
                </div>
                <div class="right">
                    <select name="type" class="select_type_field">
                        <option value="text">TEXT</option>
                        <option value="checkbox">CHECKBOX</option>
                        <option value="select">SELECT</option>
                    </select>
                </div>
                <div class="clear"></div>
            </div>
            <div class="item">
                <div class="left">
                    <?php echo __('Visible name of field') ?>:
                    <span class="comment"><?php echo __('Will be displayed in errors') ?></span>
                </div>
                <div class="right">
                    <input type="text" name="label" value="" required/>
                </div>
                <div class="clear"></div>
            </div>
            <div class="item field_option_of_size">
                <div class="left">
                    <?php echo __('Max length') ?>:
                    <span class="comment"><?php echo __('Max length of saving data') ?></span>
                </div>
                <div class="right">
                    <input type="text" name="size" value="70" />
                </div>
                <div class="clear"></div>
            </div>
            <div class="item field_option_of_params" style="display:none">
                <div class="left">
                    <?php echo __('Params') ?>:
                    <span class="comment"><?php echo __('Read more in the doc') ?></span>
                </div>
                <div class="right">
                    <input style="width:110px" type="text" name="title0" value="" placeholder="<?php echo __('Name') ?>"/><input style="width:110px" type="text" name="value0" value="" placeholder="<?php echo __('Value') ?>"/>
                    <br/>
                    <a href="#" onclick="addselect(this);"><?php echo __('Add param') ?></a>
                </div>
                <div class="clear"></div>
            </div>
            <div class="item field_option_of_pattern">
                <div class="left">
                    <?php echo __('Pattern for value') ?>:
                </div>
                <div class="right">
                    <input type="text" name="pattern" value="" />
                </div>
                <div class="clear"></div>
            </div>
            <div class="item">
                <div class="left">
                    <?php echo __('Required field') ?>:
                </div>
                <div class="right">
                    <input type="checkbox" name="required" value="1" id="required" /><label for="required"></label>
                </div>
                <div class="clear"></div>
            </div>
            <div class="item submit">
                <div class="left"></div>
                <div class="right" style="float:left;">
                    <input type="submit" value="<?php echo __('Save') ?>" name="send" class="save-button" />
                </div>
                <div class="clear"></div>
            </div>
            </form>
        </div>
    </div>





<?php 
if (!empty($fields)): ?>
<?php foreach($fields as $field): ?>
    <?php
        $params = (!empty($field['params'])) ? unserialize($field['params']) : array();
        $values = (!empty($params['values'])) ? $params['values'] : '-';

        $required = (!empty($params['required'])) 
        ? '<span style="color:red;">' . __('Yes') . '</span>' 
        : '<span style="color:blue;">' . __('No') . '</span>';
    ?>
    
    <div class="popup" id="edit_<?php echo $field['id'] ?>">
        <div class="top">
            <div class="title"><?php echo __('Editing field') ?></div>
            <div class="close" onClick="closePopup('edit_<?php echo $field['id']?>')"></div>
        </div>
        <div class="items">
            <form action="additional_fields.php?m=<?php echo $_GET['m'] ?>&ac=edit&id=<?php echo $field['id'] ?>" method="POST">
            <input type="text" name="type" value="<?php echo h($field['type']) ?>" style="display:none;" />
            <div class="item">
                <div class="left">
                    <?php echo __('Visible name of field') ?>:
                    <span class="comment"><?php echo __('Will be displayed in errors') ?></span>
                </div>
                <div class="right">
                    <input type="text" name="label" value="<?php echo h($field['label']) ?>" />
                </div>
                <div class="clear"></div>
            </div>

            <div class="item field_option_of_size"<?php if($field['type'] == 'checkbox' or $field['type'] == 'select') echo ' style="display:none;"' ?>>
                <div class="left">
                    <?php echo __('Max length') ?>:
                    <span class="comment"><?php echo __('Max length of saving data') ?></span>
                </div>
                <div class="right">
                    <input type="text" name="size" value="<?php echo (!empty($field['size'])) ? h($field['size']) : ''; ?>" />
                </div>
                <div class="clear"></div>
            </div>
            <div class="item field_option_of_pattern"<?php if($field['type'] == 'checkbox' or $field['type'] == 'select') echo ' style="display:none;"' ?>>
                <div class="left">
                    <?php echo __('Pattern for value') ?>:
                    <span class="comment"><?php echo __('Max length of saving data') ?></span>
                </div>
                <div class="right">
                    <input type="text" name="pattern" value="<?php echo (!empty($params['pattern'])) ? h($params['pattern']) : ''; ?>" />
                </div>
                <div class="clear"></div>
            </div>
            <div class="item field_option_of_params"<?php if($field['type'] == 'checkbox' or $field['type'] == 'text') echo ' style="display:none;"' ?>>
                <div class="left">
                    <?php echo __('Params') ?>:
                    <span class="comment"><?php echo __('Read more in the doc') ?></span>
                </div>
                <div class="right">
                    <?php if (!empty($values) && $values != "-"): ?>
                        <?php $n = 0; ?>
                        <?php foreach(json_decode($values, true) as $value => $title): ?>
                            <input style="width:110px" type="text" name="title<?php echo $n ?>" value="<?php echo $title ?>"/><input style="width:110px" type="text" name="value<?php echo $n ?>" value="<?php echo $value ?>"/>
                            <br>
                            <?php $n++; ?>
                        <?php endforeach; ?>
                    <?php else: ?>
                        <input style="width:110px" type="text" name="title0" value="" placeholder="<?php echo __('Name') ?>"/><input style="width:110px" type="text" name="value0" value="" placeholder="<?php echo __('Value') ?>"/>
                        <br>
                    <?php endif; ?>
                    <a href="#" onclick="addselect(this);"><?php echo __('Add param') ?></a>
                </div>
                <div class="clear"></div>
            </div>
            <div class="item">
                <div class="left">
                    <?php echo __('Required field') ?>:
                </div>
                <div class="right">
                    <input id="required<?php echo $field['id'] ?>" type="checkbox" name="required" value="1"<?php if(!empty($params['required'])) echo ' checked="checked"' ?>/><label for="required<?php echo $field['id'] ?>"></label>
                </div>
                <div class="clear"></div>
            </div>
            <div class="item submit">
                <div class="left"></div>
                <div class="right" style="float:left;">
                    <input type="submit" value="<?php echo __('Save') ?>" name="send" class="save-button" />
                </div>
                <div class="clear"></div>
            </div>
            </form>
        </div>
    </div>




<?php endforeach; ?>
<?php endif; ?>




<script>
$(".select_type_field").live("click", function(){
    type = $(this).find("option:selected").val();

    option_of_size = $(this).parents(".popup").find(".field_option_of_size");
    option_of_params = $(this).parents(".popup").find(".field_option_of_params");
    option_of_pattern = $(this).parents(".popup").find(".field_option_of_pattern");
    switch (type) {
        case 'text':
            option_of_params.hide();
            option_of_size.show();
            option_of_pattern.show();
            break;
        case 'checkbox':
            option_of_params.hide();
            option_of_size.hide();
            option_of_pattern.hide();
            break;
        case 'select':
            option_of_params.show();
            if (!option_of_params.find('.right').html())
                option_of_params.find('.right').html('<input style="width:110px" type="text" name="title0" value="" placeholder="<?php echo __('Name') ?>"/><input style="width:110px" type="text" name="value0" value="" placeholder="<?php echo __('Value') ?>"/>'
                                                                +'<br><a href="#" onclick="addselect(this);"><?php echo __('Add param') ?></a>');
            option_of_size.hide();
            option_of_pattern.hide();
            break;
    }
});



function addselect(el) {
    var el,n;
    $(el).parents('.right').find('input').each(function() {
        n = $(this).attr('name').substr(5);
    });
    n++;
    $(el).before('<input style="width:110px" type="text" name="title' + n + '" value="" placeholder="<?php echo __('Name') ?>"/><input style="width:110px" type="text" name="value' + n + '" value="" placeholder="<?php echo __('Value') ?>"/><br/>')
}
</script>


<div class="list">
    <div class="title"><?php echo __('Additional fields') ?></div>
    <div onclick="openPopup('addCat');" class="add-cat-butt"><div class="add"></div><?php echo __('Add') ?></div>
    <table class="grid" cellspacing="0" style="width:100%;">
        <tr>
            <th><?php echo __('Type of field') ?></th>
            <th><?php echo __('Visible name of field') ?></th>
            <th><?php echo __('Max length') ?></th>
            <th><?php echo __('Params') ?></th>
            <th><?php echo __('Required field') ?></th>
            <th><?php echo __('Marker of field') ?></th>
            <th style="width:160px;"><?php echo __('Activity') ?></th>
        </tr>

    <?php if (!empty($fields)): ?>
    <?php foreach($fields as $field): ?>
        <?php
            $params = (!empty($field['params'])) ? unserialize($field['params']) : array();
            $values = (!empty($params['values'])) ? $params['values'] : '-';
            $field_marker = 'add_field_' . $field['field_id'];

            $required = (!empty($params['required'])) 
            ? '<span style="color:red;">' . __('Yes') . '</span>' 
            : '<span style="color:blue;">' . __('No') . '</span>';
        ?>



                <tr>
                    <td><?php echo h($field['type']); ?></td>
                    <td><?php echo h($field['label']); ?></td>
                    <td><?php echo (!empty($field['size'])) ? h($field['size']) : '-'; ?></td>
                    <td>
                    <?php if (!empty($values) && $values != "-"): ?>
                        <?php foreach(json_decode($values, true) as $value => $title): ?>
                            <?php echo $title ?> : <?php echo $value ?>
                            <br>
                        <?php endforeach; ?>
                    <?php elseif (!empty($params['pattern']) && $params['pattern'] != "-"): ?>
                            <?php echo $params['pattern'] ?>
                    <?php endif; ?>
                    </td>
                    <td><?php echo $required; ?></td>
                    <td><?php echo h(strtolower($field_marker)); ?></td>
                    <td>
                        <a class="edit" title="<?php echo __('Edit') ?>" href="#" onClick="openPopup('edit_<?php echo $field['id'] ?>')"></a>
                        <a class="delete" title="<?php echo __('Delete') ?>" href="additional_fields.php?m=<?php echo $_GET['m'] ?>&ac=del&id=<?php echo $field['id'] ?>" onClick="return confirm(<?php echo __('Are you sure?') ?>);"></a>
                    </td>
                </tr>

    <?php endforeach; ?>
    <?php else: ?>
    <div class="fps-win"><div class="h3"><?php echo __('Additional fields not found') ?></div></div>
    <?php endif; ?>
    </table>
</div>




    <?php if (!empty($_SESSION['FpsForm']['errors'])): ?>
        <script type="text/javascript">showHelpWin('<?php echo '<ul class="error">' . $_SESSION['FpsForm']['errors'] . '</ul>'; ?>', '<?php echo __('Errors') ?>');</script>
        <?php unset($_SESSION['FpsForm']); ?>
    <?php endif; ?>
<?php endif; ?>



<?php
function FpsEdit() {
    global $FpsDB;


    if (empty($_GET['id'])) redirect('/admin/additional_fields.php?m=' . $_GET['m']);
    $id = intval($_GET['id']);
    if ($id < 1) redirect('/admin/additional_fields.php?m=' . $_GET['m']);


    if (isset($_POST['send'])) {
        $error = null;
        $allow_types = array('text', 'checkbox', 'select');


        //type of field
        $type = (!empty($_POST['type']) && in_array(trim($_POST['type']), $allow_types)) ? trim($_POST['type']) : 'text';
        if (empty($_POST['label'])) 
            $error .= '<li>' . __('Empty field "visible name"') . '</li>';
        if (empty($_POST['size']) && $type != 'checkbox' && $type != 'select') 
            $error .= '<li>' . __('Empty field "max length"') . '</li>';
        if (!empty($_POST['size']) && !is_numeric($_POST['size'])) 
            $error .= '<li>' . __('Wrong chars in "max length"') . '</li>';


        //params
        $params = array();
        if (!empty($_POST['required'])) $params['required'] = 1;
        if (!empty($_POST['pattern']) && $type == 'text') $params['pattern'] = $_POST['pattern'];
        switch ($type) {
            case 'select':
                if (isset($_POST['value0']) && isset($_POST['title0'])) {
                    $n = 0;
                    $options = array();
                    while (isset($_POST['value'.$n]) && isset($_POST['title'.$n])) {
                        $options[$_POST['value'.$n]] = $_POST['title'.$n];
                        $n++;
                    }

                    $params['values'] = json_encode($options);

                } else
                    $params['values'] = '{"1" : "' . __('Yes') . '", "0" : "' . __('No') . '"}';

                break;
            default: unset($params['values']); break;
        }
        $params = serialize($params);


        //label
        $label = (!empty($_POST['label'])) ? trim($_POST['label']) : 'Add. field';

        //size
        $size = (!empty($_POST['size'])) ? intval($_POST['size']) : 70;

        if (!empty($error)) {
            $_SESSION['FpsForm'] = array('errors' => $error);
            redirect('/admin/additional_fields.php?m=' . $_GET['m']);
        }
        $data = array(
            'id' => $id,
            'label' => $label,
            'size' => $size,
            'params' => $params,

        );
        $FpsDB->save('add_fields', $data);

        //clean cache
        $Cache = new Cache;
        $Cache->clean(CACHE_MATCHING_ANY_TAG, array('module_' . $_GET['m']));
        redirect('/admin/additional_fields.php?m=' . $_GET['m']);
    }
}



function FpsAdd() {
    global $FpsDB;


    if (isset($_POST['send'])) {
        $error = null;
        $allow_types = array('text', 'checkbox', 'select');


        //type of field
        $type = (!empty($_POST['type']) && in_array(trim($_POST['type']), $allow_types)) ? trim($_POST['type']) : 'text';
        if (empty($_POST['label'])) 
            $error .= '<li>' . __('Empty field "visible name"') . '</li>';
        if (empty($_POST['size']) && $type != 'checkbox' && $type != 'select') 
            $error .= '<li>' . __('Empty field "max length"') . '</li>';
        if (!empty($_POST['size']) && !is_numeric($_POST['size'])) 
            $error .= '<li>' . __('Wrong chars in "max length"') . '</li>';


        //params
        $params = array();
        if (!empty($_POST['required'])) $params['required'] = 1;
        if (!empty($_POST['pattern']) && $type == 'text') $params['pattern'] = $_POST['pattern'];
        switch ($type) {
            case 'select':
                if (isset($_POST['value0']) && isset($_POST['title0'])) {
                    $n = 0;
                    $options = array();
                    while (isset($_POST['value'.$n]) && isset($_POST['title'.$n])) {
                        $options[$_POST['value'.$n]] = $_POST['title'.$n];
                        $n++;
                    }

                    $params['values'] = json_encode($options);

                } else
                    $params['values'] = '{"1" : "' . __('Yes') . '", "0" : "' . __('No') . '"}';

                break;
            default: unset($params['values']); break;
        }
        $params = serialize($params);


        //label
        $label = (!empty($_POST['label'])) ? trim($_POST['label']) : 'Add. field';

        //size
        $size = (!empty($_POST['size'])) ? intval($_POST['size']) : 70;


        if (!empty($error)) {
            $_SESSION['FpsForm'] = array('errors' => $error);
            redirect('/admin/additional_fields.php?m=' . $_GET['m']);
        }

        $new_id = $FpsDB->query("SELECT MIN(field_id)+1 FROM " . $FpsDB->getFullTableName('add_fields') . " AS t1 WHERE `module` = '".$_GET['m']."' and (SELECT COUNT(*) FROM " . $FpsDB->getFullTableName('add_fields') . " AS t2 WHERE  `module` = '".$_GET['m']."' and t2.field_id=t1.field_id+1)=0;");

        if (isset($new_id) and isset($new_id[0]) and isset($new_id[0]['MIN(field_id)+1']))
            $new_id = intval($new_id[0]['MIN(field_id)+1']);
        else
            $new_id = 1;

        $data = array(
            'field_id' => $new_id,
            'module' => $_GET['m'],
            'type' => $type,
            'label' => $label,
            'size' => $size,
            'params' => $params,
        );
        $FpsDB->save('add_fields', $data);

        $FpsDB->query("ALTER TABLE `" . $FpsDB->getFullTableName($_GET['m']) . "` ADD `add_field_".$new_id."` TEXT CHARACTER SET utf8 COLLATE utf8_unicode_ci NOT NULL;");

        //clean cache
        $Cache = new Cache;
        $Cache->clean(CACHE_MATCHING_ANY_TAG, array('module_' . $_GET['m']));
        redirect('/admin/additional_fields.php?m=' . $_GET['m']);
    }
}



function FpsDelete() {
    global $FpsDB;

    if (empty($_GET['id'])) redirect('/admin/additional_fields.php?m=' . $_GET['m']);
    $id = intval($_GET['id']);
    if ($id < 1) redirect('/admin/additional_fields.php?m=' . $_GET['m']);

    $where = array('id' => $_GET['id']);
    $field = $FpsDB->select('add_fields', DB_ALL, array('cond' => $where));

    if (!$field or !is_array($field[0]))
        redirect('/admin/additional_fields.php?m=' . $_GET['m']);

    $FpsDB->query("ALTER TABLE `" . $FpsDB->getFullTableName($_GET['m']) . "` DROP `add_field_".$field[0]['field_id']."`;");

    $FpsDB->query("DELETE FROM `" . $FpsDB->getFullTableName('add_fields') 
    . "` WHERE `id` = '" . $id . "' LIMIT 1");

    redirect('/admin/additional_fields.php?m=' . $_GET['m']);
}



include_once 'template/footer.php';
?>