<?php

/**
* @project    Atom-M CMS
* @package    Rules groups editor
* @url        http://atom-m.net
*/



include_once '../sys/boot.php';
include_once ROOT . '/admin/inc/adm_boot.php';


$pageTitle = __('Rules editor');


$ACL = Register::getClass('ACL');
$acl_groups = $ACL->get_group_info();
$acl_rules = $ACL->getRules();


/* SAVE GROUPS RULES */
if (isset($_POST['send'])) {
	if (!empty($acl_rules)) {
		$new_acl_rules = $acl_rules;
		foreach ($acl_rules as $mod => $rules) {
			foreach ($rules as $rule => $roles) {
                // На всякий случай удаляем повторяющиеся значения
                if (isset($new_acl_rules[$mod][$rule]['groups']))
                    $new_acl_rules[$mod][$rule]['groups'] = array_unique($new_acl_rules[$mod][$rule]['groups']);
                
				foreach ($acl_groups as $id => $params) {
                    // Меняем права группы
                    if (!empty($_POST[$mod][$rule . '_' . $id])) {
                    // Выдаем право
                        // Если еще нет разрешений, создаем список разрешенных групп
                        if (!isset($new_acl_rules[$mod][$rule]['groups']))
                            $new_acl_rules[$mod][$rule]['groups'] = array();
                        // Если в существующих разрешениях еще нет разрешения для этой группы, добавляем его
                        if (!in_array($id, $new_acl_rules[$mod][$rule]['groups'])) {
                            $new_acl_rules[$mod][$rule]['groups'][] = $id;
                        }
                    // Забираем право
                    } else {
                        // Если список разрешенных групп для права существует и группа для запрета в него входит, то удаляем её из этого списка
                        if (isset($new_acl_rules[$mod][$rule]['groups']) && ($offkey = array_search($id, $new_acl_rules[$mod][$rule]['groups'])) !== false) {
                            unset($new_acl_rules[$mod][$rule]['groups'][$offkey]);
                        }
                    }
                }
			}
            
		}
        // Сохраняем права модулей(функция сама определит в какой файл что нужно сохранить)
		$ACL->save_rules_full($new_acl_rules);
		redirect('/admin/rules.php');
	}
}




$pageNav = $pageTitle;
$pageNavr = '';

include_once R.'admin/template/header.php';
?>





<form action="rules.php" method="POST">
<div class="list rules">
<div class="title"><?php echo __('Rules editor') ?></div>
<table cellspacing="0" class="grid" style="min-width:100%">
<?php foreach ($acl_groups as $id => $gr): ?><!-- Список групп -->
     <tr class="groupname">
	    <th width="100%"><?php echo h($gr['title']); ?></th><!-- Название группы -->
		<th class="sub-opener" onclick="subMenu('<?php  echo 'group_' . $id; ?>', 'clas')"></th>
     </tr>
     <?php foreach ($acl_rules as $mod => $_rules): ?><!-- Список модулей -->
          <?php if (count($_rules) > 0): ?>
              
              <tr style="display:none" class="<?php  echo 'group_' . $id; ?>">
                  <th class="title"><?php echo __($mod,false,$mod); ?></th><!-- Название модуля -->
                  <th class="sub-opener" onclick="subMenu('<?php  echo $mod . $id; ?>', 'clas')"></th>
              </tr>
              <?php foreach ($_rules as $title => $rules): ?><!-- Список прав -->
                  <?php if (isset($rules['groups'])): ?>
                     <tr style="display:none" class="rule <?php  echo $mod . $id; ?>">
                        <td class="left"><?php echo __($title,false,$mod); ?></td><!-- Название права -->
                        <td class="right">
                        <?php  $ch_id = $mod . '_' . $id . '_' . $title; ?>
                        <input
                           name="<?php echo $mod.'['.$title.'_'.$id.']' ?>" 
                           type="checkbox" 
                           value="1" 
                           <?php if ($ACL->turn(array($mod, $title, 'groups'),false, $id)) echo 'checked="checked"' ?> 
                           id="<?php  echo $ch_id; ?>" 
                        />
                        <label for="<?php  echo $ch_id; ?>"></label>
                        </td>
                     </tr>
                  <?php endif; ?>
              <?php endforeach; ?><!-- //Список прав -->
          <?php endif; ?>
     <?php endforeach; ?><!-- //Список модулей -->
<?php endforeach; ?><!-- //Список групп -->

	<tr>
		<td align="center" colspan="<?php echo count($acl_groups) + 2 ?>">
			<input class="save-button" name="send" type="submit" value="<?php echo __('Save') ?>"  />
		</td>
	</tr>
</table>
</div>
</form>


<?php include_once R . 'admin/template/footer.php'; ?>